Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew	(revision 5513)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew	(revision 5513)
@@ -0,0 +1,160 @@
+#!/usr/bin/env bash
+
+##############################################################################
+##
+##  Gradle start up script for UN*X
+##
+##############################################################################
+
+# Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
+DEFAULT_JVM_OPTS=""
+
+APP_NAME="Gradle"
+APP_BASE_NAME=`basename "$0"`
+
+# Use the maximum available, or set MAX_FD != -1 to use that value.
+MAX_FD="maximum"
+
+warn ( ) {
+    echo "$*"
+}
+
+die ( ) {
+    echo
+    echo "$*"
+    echo
+    exit 1
+}
+
+# OS specific support (must be 'true' or 'false').
+cygwin=false
+msys=false
+darwin=false
+case "`uname`" in
+  CYGWIN* )
+    cygwin=true
+    ;;
+  Darwin* )
+    darwin=true
+    ;;
+  MINGW* )
+    msys=true
+    ;;
+esac
+
+# Attempt to set APP_HOME
+# Resolve links: $0 may be a link
+PRG="$0"
+# Need this for relative symlinks.
+while [ -h "$PRG" ] ; do
+    ls=`ls -ld "$PRG"`
+    link=`expr "$ls" : '.*-> \(.*\)$'`
+    if expr "$link" : '/.*' > /dev/null; then
+        PRG="$link"
+    else
+        PRG=`dirname "$PRG"`"/$link"
+    fi
+done
+SAVED="`pwd`"
+cd "`dirname \"$PRG\"`/" >/dev/null
+APP_HOME="`pwd -P`"
+cd "$SAVED" >/dev/null
+
+CLASSPATH=$APP_HOME/gradle/wrapper/gradle-wrapper.jar
+
+# Determine the Java command to use to start the JVM.
+if [ -n "$JAVA_HOME" ] ; then
+    if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+        # IBM's JDK on AIX uses strange locations for the executables
+        JAVACMD="$JAVA_HOME/jre/sh/java"
+    else
+        JAVACMD="$JAVA_HOME/bin/java"
+    fi
+    if [ ! -x "$JAVACMD" ] ; then
+        die "ERROR: JAVA_HOME is set to an invalid directory: $JAVA_HOME
+
+Please set the JAVA_HOME variable in your environment to match the
+location of your Java installation."
+    fi
+else
+    JAVACMD="java"
+    which java >/dev/null 2>&1 || die "ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
+
+Please set the JAVA_HOME variable in your environment to match the
+location of your Java installation."
+fi
+
+# Increase the maximum file descriptors if we can.
+if [ "$cygwin" = "false" -a "$darwin" = "false" ] ; then
+    MAX_FD_LIMIT=`ulimit -H -n`
+    if [ $? -eq 0 ] ; then
+        if [ "$MAX_FD" = "maximum" -o "$MAX_FD" = "max" ] ; then
+            MAX_FD="$MAX_FD_LIMIT"
+        fi
+        ulimit -n $MAX_FD
+        if [ $? -ne 0 ] ; then
+            warn "Could not set maximum file descriptor limit: $MAX_FD"
+        fi
+    else
+        warn "Could not query maximum file descriptor limit: $MAX_FD_LIMIT"
+    fi
+fi
+
+# For Darwin, add options to specify how the application appears in the dock
+if $darwin; then
+    GRADLE_OPTS="$GRADLE_OPTS \"-Xdock:name=$APP_NAME\" \"-Xdock:icon=$APP_HOME/media/gradle.icns\""
+fi
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin ; then
+    APP_HOME=`cygpath --path --mixed "$APP_HOME"`
+    CLASSPATH=`cygpath --path --mixed "$CLASSPATH"`
+    JAVACMD=`cygpath --unix "$JAVACMD"`
+
+    # We build the pattern for arguments to be converted via cygpath
+    ROOTDIRSRAW=`find -L / -maxdepth 1 -mindepth 1 -type d 2>/dev/null`
+    SEP=""
+    for dir in $ROOTDIRSRAW ; do
+        ROOTDIRS="$ROOTDIRS$SEP$dir"
+        SEP="|"
+    done
+    OURCYGPATTERN="(^($ROOTDIRS))"
+    # Add a user-defined pattern to the cygpath arguments
+    if [ "$GRADLE_CYGPATTERN" != "" ] ; then
+        OURCYGPATTERN="$OURCYGPATTERN|($GRADLE_CYGPATTERN)"
+    fi
+    # Now convert the arguments - kludge to limit ourselves to /bin/sh
+    i=0
+    for arg in "$@" ; do
+        CHECK=`echo "$arg"|egrep -c "$OURCYGPATTERN" -`
+        CHECK2=`echo "$arg"|egrep -c "^-"`                                 ### Determine if an option
+
+        if [ $CHECK -ne 0 ] && [ $CHECK2 -eq 0 ] ; then                    ### Added a condition
+            eval `echo args$i`=`cygpath --path --ignore --mixed "$arg"`
+        else
+            eval `echo args$i`="\"$arg\""
+        fi
+        i=$((i+1))
+    done
+    case $i in
+        (0) set -- ;;
+        (1) set -- "$args0" ;;
+        (2) set -- "$args0" "$args1" ;;
+        (3) set -- "$args0" "$args1" "$args2" ;;
+        (4) set -- "$args0" "$args1" "$args2" "$args3" ;;
+        (5) set -- "$args0" "$args1" "$args2" "$args3" "$args4" ;;
+        (6) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" ;;
+        (7) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" ;;
+        (8) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" ;;
+        (9) set -- "$args0" "$args1" "$args2" "$args3" "$args4" "$args5" "$args6" "$args7" "$args8" ;;
+    esac
+fi
+
+# Split up the JVM_OPTS And GRADLE_OPTS values into an array, following the shell quoting and substitution rules
+function splitJvmOpts() {
+    JVM_OPTS=("$@")
+}
+eval splitJvmOpts $DEFAULT_JVM_OPTS $JAVA_OPTS $GRADLE_OPTS
+JVM_OPTS[${#JVM_OPTS[*]}]="-Dorg.gradle.appname=$APP_BASE_NAME"
+
+exec "$JAVACMD" "${JVM_OPTS[@]}" -classpath "$CLASSPATH" org.gradle.wrapper.GradleWrapperMain "$@"
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew.bat
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew.bat	(revision 5513)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/gradlew.bat	(revision 5513)
@@ -0,0 +1,90 @@
+@if "%DEBUG%" == "" @echo off
+@rem ##########################################################################
+@rem
+@rem  Gradle startup script for Windows
+@rem
+@rem ##########################################################################
+
+@rem Set local scope for the variables with windows NT shell
+if "%OS%"=="Windows_NT" setlocal
+
+@rem Add default JVM options here. You can also use JAVA_OPTS and GRADLE_OPTS to pass JVM options to this script.
+set DEFAULT_JVM_OPTS=
+
+set DIRNAME=%~dp0
+if "%DIRNAME%" == "" set DIRNAME=.
+set APP_BASE_NAME=%~n0
+set APP_HOME=%DIRNAME%
+
+@rem Find java.exe
+if defined JAVA_HOME goto findJavaFromJavaHome
+
+set JAVA_EXE=java.exe
+%JAVA_EXE% -version >NUL 2>&1
+if "%ERRORLEVEL%" == "0" goto init
+
+echo.
+echo ERROR: JAVA_HOME is not set and no 'java' command could be found in your PATH.
+echo.
+echo Please set the JAVA_HOME variable in your environment to match the
+echo location of your Java installation.
+
+goto fail
+
+:findJavaFromJavaHome
+set JAVA_HOME=%JAVA_HOME:"=%
+set JAVA_EXE=%JAVA_HOME%/bin/java.exe
+
+if exist "%JAVA_EXE%" goto init
+
+echo.
+echo ERROR: JAVA_HOME is set to an invalid directory: %JAVA_HOME%
+echo.
+echo Please set the JAVA_HOME variable in your environment to match the
+echo location of your Java installation.
+
+goto fail
+
+:init
+@rem Get command-line arguments, handling Windowz variants
+
+if not "%OS%" == "Windows_NT" goto win9xME_args
+if "%@eval[2+2]" == "4" goto 4NT_args
+
+:win9xME_args
+@rem Slurp the command line arguments.
+set CMD_LINE_ARGS=
+set _SKIP=2
+
+:win9xME_args_slurp
+if "x%~1" == "x" goto execute
+
+set CMD_LINE_ARGS=%*
+goto execute
+
+:4NT_args
+@rem Get arguments from the 4NT Shell from JP Software
+set CMD_LINE_ARGS=%$
+
+:execute
+@rem Setup the command line
+
+set CLASSPATH=%APP_HOME%\gradle\wrapper\gradle-wrapper.jar
+
+@rem Execute Gradle
+"%JAVA_EXE%" %DEFAULT_JVM_OPTS% %JAVA_OPTS% %GRADLE_OPTS% "-Dorg.gradle.appname=%APP_BASE_NAME%" -classpath "%CLASSPATH%" org.gradle.wrapper.GradleWrapperMain %CMD_LINE_ARGS%
+
+:end
+@rem End local scope for the variables with windows NT shell
+if "%ERRORLEVEL%"=="0" goto mainEnd
+
+:fail
+rem Set variable GRADLE_EXIT_CONSOLE if you need the _script_ return code instead of
+rem the _cmd.exe /c_ return code!
+if  not "" == "%GRADLE_EXIT_CONSOLE%" exit 1
+exit /b 1
+
+:mainEnd
+if "%OS%"=="Windows_NT" endlocal
+
+:omega
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/settings.gradle
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/settings.gradle	(revision 5513)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/android/settings.gradle	(revision 5513)
@@ -0,0 +1,1 @@
+include ':app'
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample.java
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample.java	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample.java	(revision 5513)
@@ -85,6 +85,19 @@
 	private static MyAppObserver observer = new MyObserver();
 	private static MyAccount account = null;
-	private static AccountConfig accCfg = null;			
-	
+	private static AccountConfig accCfg = null;		
+
+        // Snippet code to set native window to output video 
+        /*
+        private void setOutputVidWin() {}
+                VideoWindowHandle vidWH = new VideoWindowHandle();	
+                vidWH.getHandle().setWindow(getNativeWindow());
+                try {
+                        currentCall.vidWin.setWindow(vidWH);			
+                } catch (Exception e) {                        
+                        System.out.println(e);
+                }        
+        }
+        */
+
 	private static void runWorker() {
 		try {					
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample2.java
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample2.java	(revision 5513)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/java/sample2.java	(revision 5513)
@@ -0,0 +1,167 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2013 Teluu Inc. (http://www.teluu.com)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+ 
+package org.pjsip.pjsua2.app;
+
+import java.io.IOException;
+import org.pjsip.pjsua2.*;
+import org.pjsip.pjsua2.app.*;
+import javafx.application.Application;
+import javafx.event.ActionEvent;
+import javafx.event.EventHandler;
+import javafx.scene.Scene;
+import javafx.scene.layout.StackPane;
+import javafx.stage.Stage;
+import com.sun.javafx.tk.TKStage;
+import java.lang.reflect.Method;
+
+class MyObserver implements MyAppObserver {
+	private static MyCall currentCall = null;
+	
+	@Override
+	public void notifyRegState(pjsip_status_code code, String reason, int expiration) {}
+	
+	@Override
+	public void notifyIncomingCall(MyCall call) {
+		/* Auto answer. */
+		CallOpParam call_param = new CallOpParam();
+		call_param.setStatusCode(pjsip_status_code.PJSIP_SC_OK);
+		try {
+			currentCall = call;
+			currentCall.answer(call_param);
+		} catch (Exception e) {
+			System.out.println(e);
+			return;
+		}	
+	}
+	
+	@Override
+	public void notifyCallMediaState(MyCall call) {
+	}
+
+	public void notifyCallState(MyCall call) {
+		if (currentCall == null || call.getId() != currentCall.getId())
+			return;
+
+		CallInfo ci;
+		try {
+			ci = call.getInfo();
+		} catch (Exception e) {
+			ci = null;
+		}
+		if (ci.getState() == pjsip_inv_state.PJSIP_INV_STATE_DISCONNECTED) {
+			currentCall = null;                        
+		} else if (ci.getState() == pjsip_inv_state.PJSIP_INV_STATE_CONFIRMED) {
+			if (ci.getSetting().getVideoCount() != 0) {
+				System.out.println("Changing video window using " + sample2.hwnd);
+				// Change window
+				VideoWindowHandle vidWH = new VideoWindowHandle();	
+				vidWH.getHandle().setWindow(sample2.hwnd);	    	    
+				try {
+					currentCall.vidWin.setWindow(vidWH);			
+				} catch (Exception e) {
+					System.out.println(e);
+				}		 		
+			}
+		}		
+	}
+
+	@Override
+	public void notifyBuddyState(MyBuddy buddy) {}	
+}
+
+class MyThread extends Thread {
+	private static MyApp app = new MyApp();
+	private static MyAppObserver observer = new MyObserver();
+	private static MyAccount account = null;
+	private static AccountConfig accCfg = null;		     
+	
+	public void run() {
+		try {					
+			app.init(observer, ".", true);
+		} catch (Exception e) {
+			System.out.println(e);
+			app.deinit();
+			System.exit(-1);
+		}                 
+
+		if (app.accList.size() == 0) {
+			accCfg = new AccountConfig();
+			accCfg.setIdUri("sip:localhost");
+			accCfg.getVideoConfig().setAutoTransmitOutgoing(true);
+			accCfg.getVideoConfig().setAutoShowIncoming(true);                        
+			account = app.addAcc(accCfg);                        
+		} else {
+			account = app.accList.get(0);
+			accCfg = account.cfg;
+		}
+
+		try {
+			account.modify(accCfg);
+		} catch (Exception e) {}
+
+		while (!Thread.currentThread().isInterrupted()) {
+			MyApp.ep.libHandleEvents(10);
+			try {
+				Thread.currentThread().sleep(50);
+			} catch (InterruptedException ie) {
+				break;
+			}
+		}    
+                app.deinit();
+	}		
+}
+
+public class sample2 extends Application {
+	public static long hwnd;
+	private static Thread myThread = new MyThread();
+
+	private static long getWindowPointer(Stage stage) {
+		try {
+			TKStage tkStage = stage.impl_getPeer();
+			Method getPlatformWindow = tkStage.getClass().getDeclaredMethod("getPlatformWindow" );
+			getPlatformWindow.setAccessible(true);
+			Object platformWindow = getPlatformWindow.invoke(tkStage);
+			Method getNativeHandle = platformWindow.getClass().getMethod( "getNativeHandle" );
+			getNativeHandle.setAccessible(true);
+			return (long)getNativeHandle.invoke(platformWindow);
+                } catch (Throwable e) {
+			System.err.println("Error getting Window Pointer");
+			return 0;
+                }
+	}
+        
+	@Override
+	public void start(Stage primaryStage) {
+		primaryStage.setTitle("Pjsua2 javafx sample");
+		StackPane root = new StackPane();                
+		primaryStage.setScene(new Scene(root, 300, 250));
+		primaryStage.show();
+		hwnd = getWindowPointer(primaryStage);
+		myThread.start();
+	}          
+	@Override
+	public void stop() throws Exception {
+		myThread.interrupt();
+		myThread.join();
+	}                
+	public static void main(String argv[]) {
+		launch(argv);
+	}        
+}
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/pjsua2.i
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/pjsua2.i	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/pjsua2.i	(revision 5513)
@@ -115,4 +115,7 @@
 %template(CodecFmtpVector)		std::vector<pj::CodecFmtp>;	
 
+%ignore pj::WindowHandle::display;
+%ignore pj::WindowHandle::window;
+
 /* pj::WindowHandle::setWindow() receives Surface object */
 #if defined(SWIGJAVA) && defined(__ANDROID__)
@@ -124,6 +127,4 @@
 #endif
 %}
-%ignore pj::WindowHandle::display;
-%ignore pj::WindowHandle::window;
 %typemap(in) jobject surface {
     $1 = ($input? (jobject)ANativeWindow_fromSurface(jenv, $input): NULL);
@@ -131,4 +132,8 @@
 %extend pj::WindowHandle {
     void setWindow(jobject surface) { $self->window = surface; }
+}
+#else
+%extend pj::WindowHandle {
+    void setWindow(long long hwnd) { $self->window = (void*)hwnd; }
 }
 #endif
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/python/setup.py
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/python/setup.py	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/python/setup.py	(revision 5513)
@@ -62,6 +62,9 @@
 #print 'PJ_VERSION = "'+ pj_version + '"'
 
+# Get 'make' from environment variable if any
+MAKE = os.environ.get('MAKE') or "make"
+
 # Get targetname
-f = os.popen("make --no-print-directory -f helper.mak target_name")
+f = os.popen("%s --no-print-directory -f helper.mak target_name" % MAKE)
 pj_target_name = f.read().rstrip("\r\n")
 f.close()
@@ -69,5 +72,5 @@
 # Fill in extra_compile_args
 extra_compile_args = []
-f = os.popen("make --no-print-directory -f helper.mak cflags")
+f = os.popen("%s --no-print-directory -f helper.mak cflags" % MAKE)
 for line in f:
     extra_compile_args.append(line.rstrip("\r\n"))
@@ -76,5 +79,5 @@
 # Fill in libraries
 libraries = []
-f = os.popen("make --no-print-directory -f helper.mak libs")
+f = os.popen("%s --no-print-directory -f helper.mak libs" % MAKE)
 for line in f:
     libraries.append(line.rstrip("\r\n"))
@@ -83,5 +86,5 @@
 # Fill in extra_link_args
 extra_link_args = []
-f = os.popen("make --no-print-directory -f helper.mak ldflags")
+f = os.popen("%s --no-print-directory -f helper.mak ldflags" % MAKE)
 for line in f:
     extra_link_args.append(line.rstrip("\r\n"))
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.i
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.i	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.i	(revision 5513)
@@ -17,5 +17,5 @@
 enum pj_log_decoration {PJ_LOG_HAS_DAY_NAME = 1, PJ_LOG_HAS_YEAR = 2, PJ_LOG_HAS_MONTH = 4, PJ_LOG_HAS_DAY_OF_MON = 8, PJ_LOG_HAS_TIME = 16, PJ_LOG_HAS_MICRO_SEC = 32, PJ_LOG_HAS_SENDER = 64, PJ_LOG_HAS_NEWLINE = 128, PJ_LOG_HAS_CR = 256, PJ_LOG_HAS_SPACE = 512, PJ_LOG_HAS_COLOR = 1024, PJ_LOG_HAS_LEVEL_TEXT = 2048, PJ_LOG_HAS_THREAD_ID = 4096, PJ_LOG_HAS_THREAD_SWC = 8192, PJ_LOG_HAS_INDENT = 16384};
 
-typedef enum pj_qos_type {PJ_QOS_TYPE_BEST_EFFORT, PJ_QOS_TYPE_BACKGROUND, PJ_QOS_TYPE_VIDEO, PJ_QOS_TYPE_VOICE, PJ_QOS_TYPE_CONTROL} pj_qos_type;
+typedef enum pj_qos_type {PJ_QOS_TYPE_BEST_EFFORT, PJ_QOS_TYPE_BACKGROUND, PJ_QOS_TYPE_VIDEO, PJ_QOS_TYPE_VOICE, PJ_QOS_TYPE_CONTROL, PJ_QOS_TYPE_SIGNALLING} pj_qos_type;
 
 typedef enum pj_qos_flag {PJ_QOS_PARAM_HAS_DSCP = 1, PJ_QOS_PARAM_HAS_SO_PRIO = 2, PJ_QOS_PARAM_HAS_WMM = 4} pj_qos_flag;
@@ -43,4 +43,6 @@
 typedef enum pjmedia_srtp_use {PJMEDIA_SRTP_DISABLED, PJMEDIA_SRTP_OPTIONAL, PJMEDIA_SRTP_MANDATORY} pjmedia_srtp_use;
 
+typedef enum pjmedia_srtp_crypto_option {PJMEDIA_SRTP_NO_ENCRYPTION = 1, PJMEDIA_SRTP_NO_AUTHENTICATION = 2} pjmedia_srtp_crypto_option;
+
 typedef enum pjmedia_vid_stream_rc_method {PJMEDIA_VID_STREAM_RC_NONE = 0, PJMEDIA_VID_STREAM_RC_SIMPLE_BLOCKING = 1} pjmedia_vid_stream_rc_method;
 
@@ -51,7 +53,7 @@
 typedef enum pjmedia_vid_dev_cap {PJMEDIA_VID_DEV_CAP_FORMAT = 1, PJMEDIA_VID_DEV_CAP_INPUT_SCALE = 2, PJMEDIA_VID_DEV_CAP_OUTPUT_WINDOW = 4, PJMEDIA_VID_DEV_CAP_OUTPUT_RESIZE = 8, PJMEDIA_VID_DEV_CAP_OUTPUT_POSITION = 16, PJMEDIA_VID_DEV_CAP_OUTPUT_HIDE = 32, PJMEDIA_VID_DEV_CAP_INPUT_PREVIEW = 64, PJMEDIA_VID_DEV_CAP_ORIENTATION = 128, PJMEDIA_VID_DEV_CAP_SWITCH = 256, PJMEDIA_VID_DEV_CAP_OUTPUT_WINDOW_FLAGS = 512, PJMEDIA_VID_DEV_CAP_MAX = 16384} pjmedia_vid_dev_cap;
 
-typedef enum pjmedia_aud_dev_route {PJMEDIA_AUD_DEV_ROUTE_DEFAULT = 0, PJMEDIA_AUD_DEV_ROUTE_LOUDSPEAKER = 1, PJMEDIA_AUD_DEV_ROUTE_EARPIECE = 2, PJMEDIA_AUD_DEV_ROUTE_BLUETOOTH = 4} pjmedia_aud_dev_route;
+typedef enum pjmedia_aud_dev_route {PJMEDIA_AUD_DEV_ROUTE_DEFAULT = 0, PJMEDIA_AUD_DEV_ROUTE_LOUDSPEAKER = 1, PJMEDIA_AUD_DEV_ROUTE_EARPIECE = 2, PJMEDIA_AUD_DEV_ROUTE_BLUETOOTH = 4, PJMEDIA_AUD_DEV_ROUTE_CUSTOM = 128} pjmedia_aud_dev_route;
 
-typedef enum pjmedia_aud_dev_cap {PJMEDIA_AUD_DEV_CAP_EXT_FORMAT = 1, PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY = 2, PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY = 4, PJMEDIA_AUD_DEV_CAP_INPUT_VOLUME_SETTING = 8, PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING = 16, PJMEDIA_AUD_DEV_CAP_INPUT_SIGNAL_METER = 32, PJMEDIA_AUD_DEV_CAP_OUTPUT_SIGNAL_METER = 64, PJMEDIA_AUD_DEV_CAP_INPUT_ROUTE = 128, PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE = 256, PJMEDIA_AUD_DEV_CAP_EC = 512, PJMEDIA_AUD_DEV_CAP_EC_TAIL = 1024, PJMEDIA_AUD_DEV_CAP_VAD = 2048, PJMEDIA_AUD_DEV_CAP_CNG = 4096, PJMEDIA_AUD_DEV_CAP_PLC = 8192, PJMEDIA_AUD_DEV_CAP_MAX = 16384} pjmedia_aud_dev_cap;
+typedef enum pjmedia_aud_dev_cap {PJMEDIA_AUD_DEV_CAP_EXT_FORMAT = 1, PJMEDIA_AUD_DEV_CAP_INPUT_LATENCY = 2, PJMEDIA_AUD_DEV_CAP_OUTPUT_LATENCY = 4, PJMEDIA_AUD_DEV_CAP_INPUT_VOLUME_SETTING = 8, PJMEDIA_AUD_DEV_CAP_OUTPUT_VOLUME_SETTING = 16, PJMEDIA_AUD_DEV_CAP_INPUT_SIGNAL_METER = 32, PJMEDIA_AUD_DEV_CAP_OUTPUT_SIGNAL_METER = 64, PJMEDIA_AUD_DEV_CAP_INPUT_ROUTE = 128, PJMEDIA_AUD_DEV_CAP_INPUT_SOURCE = 128, PJMEDIA_AUD_DEV_CAP_OUTPUT_ROUTE = 256, PJMEDIA_AUD_DEV_CAP_EC = 512, PJMEDIA_AUD_DEV_CAP_EC_TAIL = 1024, PJMEDIA_AUD_DEV_CAP_VAD = 2048, PJMEDIA_AUD_DEV_CAP_CNG = 4096, PJMEDIA_AUD_DEV_CAP_PLC = 8192, PJMEDIA_AUD_DEV_CAP_MAX = 16384} pjmedia_aud_dev_cap;
 
 enum pjmedia_file_writer_option {PJMEDIA_FILE_WRITE_PCM = 0, PJMEDIA_FILE_WRITE_ALAW = 1, PJMEDIA_FILE_WRITE_ULAW = 2};
@@ -134,5 +136,5 @@
 typedef enum pjsua_state {PJSUA_STATE_NULL, PJSUA_STATE_CREATED, PJSUA_STATE_INIT, PJSUA_STATE_STARTING, PJSUA_STATE_RUNNING, PJSUA_STATE_CLOSING} pjsua_state;
 
-typedef enum pjsua_stun_use {PJSUA_STUN_USE_DEFAULT, PJSUA_STUN_USE_DISABLED} pjsua_stun_use;
+typedef enum pjsua_stun_use {PJSUA_STUN_USE_DEFAULT, PJSUA_STUN_USE_DISABLED, PJSUA_STUN_RETRY_ON_FAILURE} pjsua_stun_use;
 
 typedef enum pjsua_call_hold_type {PJSUA_CALL_HOLD_TYPE_RFC3264, PJSUA_CALL_HOLD_TYPE_RFC2543} pjsua_call_hold_type;
@@ -162,6 +164,8 @@
 typedef enum pjsua_vid_req_keyframe_method {PJSUA_VID_REQ_KEYFRAME_SIP_INFO = 1, PJSUA_VID_REQ_KEYFRAME_RTCP_PLI = 2} pjsua_vid_req_keyframe_method;
 
-typedef enum pjsua_call_flag {PJSUA_CALL_UNHOLD = 1, PJSUA_CALL_UPDATE_CONTACT = 2, PJSUA_CALL_INCLUDE_DISABLED_MEDIA = 4, PJSUA_CALL_NO_SDP_OFFER = 8} pjsua_call_flag;
+typedef enum pjsua_call_flag {PJSUA_CALL_UNHOLD = 1, PJSUA_CALL_UPDATE_CONTACT = 2, PJSUA_CALL_INCLUDE_DISABLED_MEDIA = 4, PJSUA_CALL_NO_SDP_OFFER = 8, PJSUA_CALL_REINIT_MEDIA = 16, PJSUA_CALL_UPDATE_VIA = 32} pjsua_call_flag;
 
 typedef enum pjsua_create_media_transport_flag {PJSUA_MED_TP_CLOSE_MEMBER = 1} pjsua_create_media_transport_flag;
 
+typedef enum pjsua_snd_dev_mode {PJSUA_SND_DEV_SPEAKER_ONLY = 1, PJSUA_SND_DEV_NO_IMMEDIATE_OPEN = 2} pjsua_snd_dev_mode;
+
Index: pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.lst
===================================================================
--- pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.lst	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip-apps/src/swig/symbols.lst	(revision 5513)
@@ -9,5 +9,5 @@
 
 pjmedia/event.h                 pjmedia_event_type
-pjmedia/transport_srtp.h	pjmedia_srtp_use
+pjmedia/transport_srtp.h	pjmedia_srtp_use pjmedia_srtp_crypto_option
 pjmedia/vid_stream.h		pjmedia_vid_stream_rc_method
 pjmedia-videodev/videodev.h	pjmedia_vid_dev_index pjmedia_vid_dev_std_index pjmedia_vid_dev_cap
@@ -34,3 +34,3 @@
 pjsip-ua/sip_inv.h              pjsip_inv_state
 
-pjsua-lib/pjsua.h		pjsua_invalid_id_const_ pjsua_state pjsua_stun_use pjsua_call_hold_type pjsua_acc_id pjsua_destroy_flag pjsua_100rel_use pjsua_sip_timer_use pjsua_ipv6_use pjsua_buddy_status pjsua_call_media_status pjsua_vid_win_id pjsua_call_id pjsua_med_tp_st pjsua_call_vid_strm_op pjsua_vid_req_keyframe_method pjsua_call_flag pjsua_create_media_transport_flag
+pjsua-lib/pjsua.h		pjsua_invalid_id_const_ pjsua_state pjsua_stun_use pjsua_call_hold_type pjsua_acc_id pjsua_destroy_flag pjsua_100rel_use pjsua_sip_timer_use pjsua_ipv6_use pjsua_buddy_status pjsua_call_media_status pjsua_vid_win_id pjsua_call_id pjsua_med_tp_st pjsua_call_vid_strm_op pjsua_vid_req_keyframe_method pjsua_call_flag pjsua_create_media_transport_flag pjsua_snd_dev_mode
Index: pjproject/branches/projects/uwp/pjsip/docs/doxygen.cfg
===================================================================
--- pjproject/branches/projects/uwp/pjsip/docs/doxygen.cfg	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/docs/doxygen.cfg	(revision 5513)
@@ -847,4 +847,5 @@
 PREDEFINED             = PJ_DECL(x)=x PJ_DEF(x)=x PJ_IDECL(x)=x \
 			 PJ_IDEF(x)=x PJ_INLINE(x)=x PJ_DECL_DATA(x)=x \
+			 PJ_HAS_TCP=1 \
 			 PJMEDIA_HAS_SRTP=1 \
 			 PJMEDIA_STREAM_ENABLE_KA=1
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip-simple/evsub.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip-simple/evsub.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip-simple/evsub.h	(revision 5513)
@@ -247,5 +247,6 @@
  * @param event_name	Event package identification.
  * @param expires	Default subscription expiration time, in seconds.
- * @param accept_cnt	Number of strings in Accept array.
+ * @param accept_cnt	Number of strings in Accept array. The value must
+ *			not be greater than PJSIP_GENERIC_ARRAY_MAX_COUNT.
  * @param accept	Array of Accept value.
  *
@@ -491,4 +492,24 @@
 
 
+/**
+ * Increment the event subscription's group lock.
+ *
+ * @param sub		The server subscription instance.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DEF(pj_status_t) pjsip_evsub_add_ref(pjsip_evsub *sub);
+
+
+/**
+ * Decrement the event subscription's group lock.
+ *
+ * @param sub		The server subscription instance.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DEF(pj_status_t) pjsip_evsub_dec_ref(pjsip_evsub *sub);
+
+
 
 PJ_END_DECL
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_inv.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_inv.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_inv.h	(revision 5513)
@@ -384,4 +384,9 @@
  * that the flip-flop pool's lifetimes are synchronized to the
  * SDP offer-answer negotiation.
+ *
+ * The lifetime of this session is controlled by the reference counter in this
+ * structure, which is manipulated by calling #pjsip_inv_add_ref and
+ * #pjsip_inv_dec_ref. When the reference counter has reached zero, then
+ * this session will be destroyed.
  */
 struct pjsip_inv_session
@@ -413,4 +418,5 @@
     pj_bool_t		 following_fork;	    /**< Internal, following
 							 forked media?	    */
+    pj_atomic_t		*ref_cnt;		    /**< Reference counter. */
 };
 
@@ -629,4 +635,28 @@
 					  unsigned options,
 					  pjsip_inv_session **p_inv);
+
+
+/**
+ * Add reference counter to the INVITE session. The reference counter controls
+ * the life time of the session, ie. when the counter reaches zero, then it 
+ * will be destroyed.
+ *
+ * @param inv       The INVITE session.
+ * @return          PJ_SUCCESS if the INVITE session reference counter
+ *                  was increased.
+ */
+PJ_DECL(pj_status_t) pjsip_inv_add_ref( pjsip_inv_session *inv );
+
+/**
+ * Decrement reference counter of the INVITE session.
+ * When the session is no longer used, it will be destroyed and
+ * caller is informed with PJ_EGONE return status.
+ *
+ * @param inv       The INVITE session.
+ * @return          PJ_SUCCESS if the INVITE session reference counter
+ *                  was decreased. A status PJ_EGONE will be returned to 
+ *                  inform that session is destroyed.
+ */
+PJ_DECL(pj_status_t) pjsip_inv_dec_ref( pjsip_inv_session *inv );
 
 
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_regc.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_regc.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_regc.h	(revision 5513)
@@ -78,4 +78,5 @@
     int			 contact_cnt;/**<Number of contacts in response.    */
     pjsip_contact_hdr	*contact[PJSIP_REGC_MAX_CONTACT]; /**< Contacts.    */
+    pj_bool_t		 is_unreg;  /**< Expire header, if any, set to zero?*/
 };
 
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_replaces.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_replaces.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip-ua/sip_replaces.h	(revision 5513)
@@ -139,5 +139,5 @@
     // Create UAS Invite session as usual.
     //
-    status = pjsip_dlg_create_uas(.., rdata, .., &dlg);
+    status = pjsip_dlg_create_uas_and_inc_lock(.., rdata, .., &dlg);
     ..
     status = pjsip_inv_create_uas(dlg, .., &inv);
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip/print_util.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip/print_util.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip/print_util.h	(revision 5513)
@@ -30,6 +30,8 @@
 	do { \
 	    if ((str).slen >= (endbuf-buf)) return -1;	\
-	    pj_memcpy(buf, (str).ptr, (str).slen); \
-	    buf += (str).slen; \
+	    if ((str).slen) { \
+		pj_memcpy(buf, (str).ptr, (str).slen); \
+		buf += (str).slen; \
+	    } \
 	} while (0)
 
@@ -106,4 +108,8 @@
 #define copy_advance_pair 	copy_advance_pair_check
 
+/*
+ * Append str1 and quoted str2 and copy to buf. 
+ * No string is copied if str2 is empty.
+ */
 #define copy_advance_pair_quote_cond(buf,str1,len1,str2,quotebegin,quoteend) \
 	do {	\
@@ -113,4 +119,17 @@
 	    copy_advance_pair(buf,str1,len1,str2); \
 	} while (0)
+
+/*
+ * Append str1 and quoted str2 and copy to buf. 
+ * In case str2 is empty, str1 will be appended with empty quote.
+ */
+#define copy_advance_pair_quote_cond_always(buf,str1,len1,str2,quotebegin, \
+					    quoteend)\
+    do {	\
+       if (!str2.slen) \
+         copy_advance_pair_quote(buf,str1,len1,str2,quotebegin,quoteend); \
+       else \
+	 copy_advance_pair_quote_cond(buf,str1,len1,str2,quotebegin,quoteend);\
+    } while (0)
 
 /*
Index: pjproject/branches/projects/uwp/pjsip/include/pjsip/sip_auth.h
===================================================================
--- pjproject/branches/projects/uwp/pjsip/include/pjsip/sip_auth.h	(revision 5512)
+++ pjproject/branches/projects/uwp/pjsip/include/pjsip/sip_auth.h	(revision 5513)
@@ -167,4 +167,5 @@
     PJ_DECL_LIST_MEMBER(struct pjsip_cached_auth);
 
+    pj_pool_t			*pool;      /**< Pool for cached auth	    */
     pj_str_t			 realm;	    /**< Realm.			    */
     pj_bool_t			 is_proxy;  /**< Server type (401/407)	    */
@@ -342,4 +343,14 @@
 
 /**
+ * Deinitialize client authentication session data structure.
+ *
+ * @param sess		The client authentication session.
+ *
+ * @return		PJ_SUCCESS on success.
+ */
+PJ_DECL(pj_status_t) pjsip_auth_clt_deinit( pjsip_auth_clt_sess *sess);
+
+
+/**
  * Clone client initialization session. 
  *
